var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var data_sources_field_model_exports = {};
__export(data_sources_field_model_exports, {
  DataSourcesFieldModel: () => DataSourcesFieldModel
});
module.exports = __toCommonJS(data_sources_field_model_exports);
var import_database = require("@nocobase/database");
var import_utils = require("../utils");
class DataSourcesFieldModel extends import_database.MagicAttributeModel {
  load(loadOptions) {
    const { app } = loadOptions;
    const options = this.get();
    const { collectionName, name, dataSourceKey } = options;
    const dataSource = app.dataSourceManager.dataSources.get(dataSourceKey);
    const collection = dataSource.collectionManager.getCollection(collectionName);
    const oldField = collection.getField(name);
    const newOptions = (0, import_utils.mergeOptions)(oldField ? oldField.options : {}, options);
    collection.setField(name, newOptions);
  }
  unload(loadOptions) {
    const { app } = loadOptions;
    const options = this.get();
    const { collectionName, name, dataSourceKey } = options;
    const dataSource = app.dataSourceManager.dataSources.get(dataSourceKey);
    if (!dataSource) {
      return;
    }
    const collection = dataSource.collectionManager.getCollection(collectionName);
    if (!collection) {
      return;
    }
    collection.removeField(name);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DataSourcesFieldModel
});
