var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var data_sources_collections_exports = {};
__export(data_sources_collections_exports, {
  default: () => data_sources_collections_default
});
module.exports = __toCommonJS(data_sources_collections_exports);
var import_lodash = __toESM(require("lodash"));
var data_sources_collections_default = {
  name: "dataSources.collections",
  actions: {
    async list(ctx, next) {
      var _a, _b;
      const params = ctx.action.params;
      const { associatedIndex: dataSourceKey } = params;
      const dataSource = ctx.app.dataSourceManager.dataSources.get(dataSourceKey);
      if (!dataSource) {
        throw new Error(`dataSource ${dataSourceKey} not found`);
      }
      const { paginate, filter } = ctx.action.params;
      const filterTitle = (_a = import_lodash.default.get(filter, "$and.0.title.$includes")) == null ? void 0 : _a.toLowerCase();
      const filterName = (_b = import_lodash.default.get(filter, "$and.0.name.$includes")) == null ? void 0 : _b.toLowerCase();
      const collections = import_lodash.default.sortBy(
        dataSource.collectionManager.getCollections().filter((collection) => {
          var _a2;
          return (!filterTitle || ((_a2 = import_lodash.default.get(collection, "options.title")) == null ? void 0 : _a2.toLowerCase().includes(filterTitle))) && (!filterName || collection.options.name.toLowerCase().includes(filterName));
        }),
        "name"
      );
      const mapCollection = (collections2) => {
        return collections2.map((collection) => {
          return {
            ...collection.options,
            fields: collection.getFields().map((field) => field.options)
          };
        });
      };
      if (paginate === false || paginate === "false") {
        ctx.body = mapCollection(collections);
      } else {
        const { page = 1, pageSize = 20 } = ctx.action.params;
        ctx.withoutDataWrapping = true;
        ctx.body = {
          data: mapCollection(collections.slice((page - 1) * pageSize, page * pageSize)),
          meta: {
            count: collections.length,
            page,
            pageSize,
            totalPage: Math.ceil(collections.length / pageSize)
          }
        };
      }
      await next();
    },
    async update(ctx, next) {
      const params = ctx.action.params;
      const { filterByTk: collectionName, associatedIndex: dataSourceKey } = params;
      let dataSourceCollectionRecord = await ctx.db.getRepository("dataSourcesCollections").findOne({
        filter: {
          name: collectionName,
          dataSourceKey
        }
      });
      if (!dataSourceCollectionRecord) {
        dataSourceCollectionRecord = await ctx.db.getRepository("dataSourcesCollections").create({
          values: {
            ...params.values,
            name: collectionName,
            dataSourceKey
          }
        });
      } else {
        await dataSourceCollectionRecord.update({
          ...params.values
        });
      }
      ctx.body = dataSourceCollectionRecord.toJSON();
      await next();
    }
  }
};
